From c115031f8af357a384f1c68736c8d3a114c3f2fb Mon Sep 17 00:00:00 2001
From: Johnson Chu <johnsoncodehk@gmail.com>
Date: Sat, 14 Dec 2024 03:46:14 +0800
Subject: [PATCH 03/10] fix(typescript): force update the opened script
 snapshot after the language plugin is ready

close #254
---
 .../createAsyncLanguageServicePlugin.ts       | 20 ++++++++++++++-----
 1 file changed, 15 insertions(+), 5 deletions(-)

diff --git a/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts b/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
index a4c42c10..78dcb88d 100644
--- a/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
+++ b/packages/typescript/lib/quickstart/createAsyncLanguageServicePlugin.ts
@@ -36,14 +36,24 @@ export function createAsyncLanguageServicePlugin(
 					let initialized = false;
 
 					info.languageServiceHost.getScriptSnapshot = fileName => {
-						if (!initialized && extensions.some(ext => fileName.endsWith(ext))) {
-							return emptySnapshot;
+						if (!initialized) {
+							if (extensions.some(ext => fileName.endsWith(ext))) {
+								return emptySnapshot;
+							}
+							if (info.project.getScriptInfo(fileName)?.isScriptOpen()) {
+								return emptySnapshot;
+							}
 						}
 						return getScriptSnapshot(fileName);
 					};
 					info.languageServiceHost.getScriptVersion = fileName => {
-						if (!initialized && extensions.some(ext => fileName.endsWith(ext))) {
-							return 'initializing...';
+						if (!initialized) {
+							if (extensions.some(ext => fileName.endsWith(ext))) {
+								return 'initializing...';
+							}
+							if (info.project.getScriptInfo(fileName)?.isScriptOpen()) {
+								return getScriptVersion(fileName) + ',initializing...';
+							}
 						}
 						return getScriptVersion(fileName);
 					};
@@ -106,10 +116,10 @@ export function createAsyncLanguageServicePlugin(
 						decorateLanguageServiceHost(ts, language, info.languageServiceHost);
 						setup?.(language);
 
+						initialized = true;
 						if ('markAsDirty' in info.project && typeof info.project.markAsDirty === 'function') {
 							info.project.markAsDirty();
 						}
-						initialized = true;
 					});
 				}
 

